#include "BMP_include.h"

#include <stdio.h>
#include <stdlib.h>



int BMP_ReadHeader (FILE *FilePNT, unsigned char BMPheader []) {

   int i;

   for (i=0; i<HeaderLen; i++)
      if (!feof (FilePNT)) BMPheader [i] = fgetc (FilePNT);
      else return (Err_EOF);

   if (BMPheader [0] != 'B') return (Err_NoBMP);

   if (BMPheader [1] != 'M') return (Err_NoBMP);

   return (Success);
}

int BMP_GetSize (unsigned char BMPheader [], int *Righe, int *Colonne) {

   *Righe   = BMPheader [alt] +
              BMPheader [alt + 1] * 256 +
              BMPheader [alt + 2] * 256 * 256 +
              BMPheader [alt + 3] * 256 * 256 * 256;
   if (*Righe > Max_Rig) return (Err_TooManyRows);


   *Colonne = BMPheader [largh] +
              BMPheader [largh + 1] * 256 +
              BMPheader [largh + 2] * 256 * 256 +
              BMPheader [largh + 3] * 256 * 256 * 256;
   if (*Colonne > Max_Rig) return (Err_TooManyCols);

   return (Success);
}

void BMP_ShowError (int Status) {

   if (Status == Err_EOF)
      fprintf (stderr, "Raggiunta prematuramente la fine del file\n");

   if (Status == Err_NoBMP)
      fprintf (stderr, "Il file non e'in formato BMP\n");

   if (Status == Err_TooManyRows)
      fprintf (stderr, "Numero di righe eccessivo\n");

   if (Status == Err_TooManyCols)
      fprintf (stderr, "Numero di colonne eccessivo\n");

   if (Status == Err_NoOpen)
      fprintf (stderr, "Errore apertura file\n");

   exit (Status);
}

long int BMP_ReadImage (FILE *FilePNT, unsigned char BMPimage []) {
   long int i;
   unsigned char ch;

   i = 0;
   ch = fgetc (FilePNT);
   while (!feof (FilePNT)) {
      BMPimage [i] = ch;
      i++;
      ch = fgetc (FilePNT);
   }
   return (i);
}
